package com.example.tlsdataupdate.es;

import com.example.tlsdataupdate.service.HyZcMysqlModelService;
import com.example.tlsdataupdate.utils.JsoupUtilsViewTls;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.elasticsearch.action.index.IndexResponse;
import org.elasticsearch.rest.RestStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class UpdateEsTongliao {
    @Autowired
    private HyZcMysqlModelService hyZcMysqlModelService;

    @Autowired
    private RestHighLevelClientUtils restHighLevelClientUtils;

    public List<HyZcMysqlModel> getHyZcMysqlModelList(String channelId,String urlNew){
        List<HyZcMysqlModel> list = hyZcMysqlModelService.listByChannelId(channelId);
        for (HyZcMysqlModel hyZcMysqlModel : list) {
            String currentFilePathHtmlUrl = hyZcMysqlModel.getCurrentFilePathHtmlUrl();
            String html = JsoupUtilsViewTls.rexStringHtml(currentFilePathHtmlUrl);
            hyZcMysqlModel.setHtmlContent(html);
            String site_url = hyZcMysqlModel.getSiteUrl();
            String channel_url = hyZcMysqlModel.getChannelUrl();
            String url = hyZcMysqlModel.getUrl();
            hyZcMysqlModel.setNewUrl(urlNew+site_url+channel_url+url);
        }
        return list;
    }

    public void updateES(HyZc hyZc){
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            String toJSONString = objectMapper.writeValueAsString(hyZc);
            IndexResponse search_hy_zc = restHighLevelClientUtils.addDoc("search_hy_zc", String.valueOf(hyZc.getId()), toJSONString);
            RestStatus status = search_hy_zc.status();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
